/*---------------------------------------------
  PS3 DUALSHOCK3
  ---------------------------------------------*/
#include <ud3.h>

//---------------------------------------------------------------------------------
// C
//---------------------------------------------------------------------------------
void main (void) {
  char led = 0;
  uint8_t l2, r2, v;
  bool toggle = true;

  // SIMPLE TERM̃VA^[~iƂ̒ʐMpɏ
  UD3_ASSIGN_USB_TO_CONSOLE ();
  UD3_ASSIGN_RS485_TO_CONSOLE ();

  // SIXAXIS̒ʐMpɏ
  UD3_ASSIGN_BT_TO_SIXAXIS ();

  while (1) {
    // LED1_
    UD3_SET_LED ((led = !led));

    if (UD3_GET_BTCONNECT ()) {
      // DUALSHOCK3瓾f[^\
      if (toggle) {
        UD3_PRINTF (
          "\rD1:%02X D2:%02X D3:%02X LX:%3d LY:%3d RX:%3d RY:%3d L2:%3d R2:%3d\33[K",
          UD3_GET_PSDIGITAL1 (),
          UD3_GET_PSDIGITAL2 (),
          UD3_GET_PSDIGITAL3 (),
          UD3_GET_PSLX (),
          UD3_GET_PSLY (),
          UD3_GET_PSRX (),
          UD3_GET_PSRY (),
          l2 = UD3_GET_PSL2 (),
          r2 = UD3_GET_PSR2 ()
        );
        // ܂
        if (l2 >= r2) v = l2;
        else if (l2 < r2) v = r2;
        if (v > 0) UD3_SET_BUZZER (v / 4, 20);
      } else {
        UD3_PRINTF (
          "\rX:%4d Y:%4d Z:%4d Gy:%4d\33[K",
          UD3_GET_PSGX (),
          UD3_GET_PSGY (),
          UD3_GET_PSGZ (),
          UD3_GET_PSGYRO ()
        );
      }

      //  PS{^̓͂邽тɃ{^ƃZT̕\؂ւ
      if (UD3_GET_PSDIGITAL3 () & 0x1) {
        toggle = !toggle;
        while (UD3_GET_BTCONNECT () && (UD3_GET_PSDIGITAL3 () & 0x1)) UD3_WAIT (10);
      }
    } else {
      UD3_PUTS ("\rNot Connected\33[K");
    }

    UD3_WAIT (10);
  }
}
